Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::ConjunctionScorer Class Reference

Scorer for conjunctions, sets of queries, all of which are required. More...

`#include <ConjunctionScorer.h>`

Inheritance diagram for Lucene::ConjunctionScorer:

## Public Member Functions

| ConjunctionScorer (const SimilarityPtr &similarity, Collection< ScorerPtr > scorers)
virtual | ~ConjunctionScorer ()
virtual String | getClassName ()
boost::shared_ptr< ConjunctionScorer > | shared_from_this ()
virtual int32_t | advance (int32_t target)
| Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or `NO_MORE_DOCS` if there are no more docs in the set.
virtual int32_t | docID ()
| Returns the following:
virtual int32_t | nextDoc ()
| Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.
virtual double | score ()
| Returns the score of the current document matching the query. Initially invalid, until `nextDoc()` or `advance(int32_t)` is called the first time, or when called from within `Collector#collect`.
Public Member Functions inherited from Lucene::Scorer
| Scorer (const SimilarityPtr &similarity)
| Constructs a Scorer.
| Scorer (const WeightPtr &weight)
virtual | ~Scorer ()
boost::shared_ptr< Scorer > | shared_from_this ()
SimilarityPtr | getSimilarity ()
| Returns the Similarity implementation used by this scorer.
virtual void | score (const CollectorPtr &collector)
| Scores and collects all matching documents.
void | visitSubScorers (QueryPtr parent, BooleanClause::Occur relationship, ScorerVisitor *visitor)
void | visitScorers (ScorerVisitor *visitor)
virtual float | termFreq ()
Public Member Functions inherited from Lucene::DocIdSetIterator
virtual | ~DocIdSetIterator ()
boost::shared_ptr< DocIdSetIterator > | shared_from_this ()
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::Scorer
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::DocIdSetIterator
static String | _getClassName ()

## Protected Member Functions

int32_t | doNext ()
Protected Member Functions inherited from Lucene::Scorer
virtual bool | score (const CollectorPtr &collector, int32_t max, int32_t firstDocID)
| Collects matching documents in a range. Hook for optimization. Note, firstDocID is added to ensure that `nextDoc()` was called before this method.
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

Collection< ScorerPtr > | scorers
double | coord
int32_t | lastDoc
Protected Attributes inherited from Lucene::Scorer
SimilarityPtr | similarity
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Data Fields inherited from Lucene::Scorer
WeightPtr | weight
Static Public Attributes inherited from Lucene::DocIdSetIterator
static const int32_t | NO_MORE_DOCS
| When returned by `nextDoc()`, `advance(int)` and `docID()` it means there are no more docs in the iterator.

## Detailed Description

Scorer for conjunctions, sets of queries, all of which are required.

## Constructor & Destructor Documentation

## ◆ ConjunctionScorer()

Lucene::ConjunctionScorer::ConjunctionScorer | ( | const SimilarityPtr & | similarity,
|  | Collection< ScorerPtr > | scorers )

References scorers, and Lucene::Scorer::similarity.

Referenced by _getClassName().

## ◆ ~ConjunctionScorer()

virtual Lucene::ConjunctionScorer::~ConjunctionScorer | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::ConjunctionScorer::_getClassName | ( |  | ) |

inline static

References ConjunctionScorer().

## ◆ advance()

virtual int32_t Lucene::ConjunctionScorer::advance | ( | int32_t | target | ) |

virtual

Advances to the first beyond the current whose document number is greater than or equal to target. Returns the current document number or `NO_MORE_DOCS` if there are no more docs in the set.

Behaves as if written:

    int32_t advance(int32_t target)
    {
        int32_t doc;
        while ((doc = nextDoc()) < target)
        { }
        return doc;
    }

Some implementations are considerably more efficient than that.

NOTE: certain implementations may return a different value (each time) if called several times in a row with the same target.

NOTE: this method may be called with {@value NO_MORE_DOCS} for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behaviour.

Implements Lucene::DocIdSetIterator.

## ◆ docID()

virtual int32_t Lucene::ConjunctionScorer::docID | ( |  | ) |

virtual

Returns the following:

- -1 or `NO_MORE_DOCS` if `nextDoc()` or `advance(int)` were not called yet.
- `NO_MORE_DOCS` if the iterator has exhausted.
- Otherwise it should return the doc ID it is currently on.

Implements Lucene::DocIdSetIterator.

## ◆ doNext()

int32_t Lucene::ConjunctionScorer::doNext | ( |  | ) |

protected

## ◆ getClassName()

virtual String Lucene::ConjunctionScorer::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::Scorer.

Reimplemented in Lucene::CountingConjunctionSumScorer.

## ◆ nextDoc()

virtual int32_t Lucene::ConjunctionScorer::nextDoc | ( |  | ) |

virtual

Advances to the next document in the set and returns the doc it is currently on, or `NO_MORE_DOCS` if there are no more docs in the set.

NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behaviour.

Implements Lucene::DocIdSetIterator.

## ◆ score()

virtual double Lucene::ConjunctionScorer::score | ( |  | ) |

virtual

Returns the score of the current document matching the query. Initially invalid, until `nextDoc()` or `advance(int32_t)` is called the first time, or when called from within `Collector#collect`.

Implements Lucene::Scorer.

Reimplemented in Lucene::CountingConjunctionSumScorer.

## ◆ shared_from_this()

boost::shared_ptr< ConjunctionScorer > Lucene::ConjunctionScorer::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ coord

double Lucene::ConjunctionScorer::coord

protected

## ◆ lastDoc

int32_t Lucene::ConjunctionScorer::lastDoc

protected

## ◆ scorers

Collection<ScorerPtr> Lucene::ConjunctionScorer::scorers

protected

Referenced by ConjunctionScorer(), and Lucene::CountingConjunctionSumScorer::CountingConjunctionSumScorer().

The documentation for this class was generated from the following file:

- ConjunctionScorer.h

clucene.sourceforge.net